let css = `body {
	background-color: [couleur];
}
h1, h2 {
	opacity: 1;
	// opacity: [opacité];
	font-family: [typo];
	font-size: [chiffre2 20:100]px;
	color: rgb([chiffre 0:255],255,255);
}`;
let parameters = `[[\"       \",\"typo\",\"sans-serif;serif;cursive;fantasy\",\"r\",\"note:10\",\"onset:E\"],[\"       \",\"chiffre\",\"0:1000\",\"i:100\",\"cc:60\",\"onset:D\"],[\"       \",\"chiffre2\",\"0:200\",\"i:10\",\"cc:60\",\"onset:E\"],[\"       \",\"couleur\",\"#000:#fff\",\"d\",\"cc:60\",\"loud\"],[\"       \",\"opacité\",\"0:1\",\"d\",\"cc:1\",\"hi\"]]`;
let activate = false;
let audioB = false;
let midiB = false;
let audioI = false;
let midiI = false;
let popup = false;
let loopPlay = false;
let records = {
	loop: [
		[
			{
				time: 1,
				data: { value: 0, controller: { number: 1 } },
				type: 'controlchange'
			},
			{
				time: 2000,
				data: { value: 1, controller: { number: 1 } },
				type: 'controlchange'
			},
			{
				time: 3000,
				data: { value: 0, controller: { number: 1 } },
				type: 'controlchange'
			}
		],
		[],
		[],
		[]
	],
	info: [
		{isLoop:false, isRecording:false, controllerPlayPause: '', controllerRecord: ''},
		{isLoop:false, isRecording:false, controllerPlayPause: '', controllerRecord: ''},
		{isLoop:false, isRecording:false, controllerPlayPause: '', controllerRecord: ''},
		{isLoop:false, isRecording:false, controllerPlayPause: '', controllerRecord: ''}
	]
};
let all = "";

//Initialize the CSS storage on startup
chrome.runtime.onInstalled.addListener(() => {
	chrome.storage.sync.set({ css });
	chrome.storage.sync.set({ activate });
	chrome.storage.sync.set({ audioB });
	chrome.storage.sync.set({ midiB });
	chrome.storage.sync.set({ audioI });
	chrome.storage.sync.set({ midiI });
	chrome.storage.sync.set({ popup });
	chrome.storage.sync.set({ loopPlay });
	chrome.storage.sync.set({ records });
	chrome.storage.sync.set({ parameters });
	chrome.storage.sync.set({ all });
});


/**
 * @description This function is called when popup is opened and add a listener when user close it.
 */
chrome.runtime.onConnect.addListener(function (port) {
	if (port.name === "popup") {
		port.onDisconnect.addListener(function () {
			chrome.storage.sync.set({ popup: false });
		});
	}
});